diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/matvecalloc.c lsqrms-2.0.4b/src/matvecalloc.c
--- lsqrms-2.0.4b.old/src/matvecalloc.c	Wed Mar 12 17:12:13 EST 2003
+++ lsqrms-2.0.4b/src/matvecalloc.c	Sun Feb 24 22:49:49 EST 2008
@@ -1,14 +1,16 @@
-#include <stdio.h>
-#include <stdlib.h>
+#include "lsqrms.h"
+#include "matvecalloc.h"
 
 #define EDGE 1
-#define RELEASE char*
 
 char *cVector(long nfirst, long nlast)
 {
    char *vtr;
-   vtr = (char *)malloc( (size_t) ((nlast-nfirst+1+EDGE)*sizeof(char)) );
-   if(!vtr) printf( "Allocation failed!\n" );
+   vtr = (char *)malloc((size_t)((nlast-nfirst+1+EDGE) * sizeof(char)));
+   if (!vtr) {
+     fprintf(stderr,"cVector: Allocation failed!\n");
+     return NULL;
+   } else
    return vtr-nfirst+EDGE;
 }
 
@@ -15,8 +17,11 @@
 int *iVector(long nfirst, long nlast)
 {
    int *vtr;
-   vtr = (int *)malloc( (size_t) ((nlast-nfirst+1+EDGE)*sizeof(int)) );
-   if(!vtr) printf( "Allocation failed!\n" );
+   vtr = (int *)malloc((size_t)((nlast-nfirst+1+EDGE) * sizeof(int)));
+   if (!vtr) {
+     fprintf(stderr,"iVector: Allocation failed!\n");
+     return NULL;
+   } else
    return vtr-nfirst+EDGE;
 }
 
@@ -23,8 +28,11 @@
 double *dVector(long nfirst, long nlast)
 {
    double *vtr;
-   vtr = (double *)malloc( (size_t) ((nlast-nfirst+1+EDGE)*sizeof(double)) );
-   if(!vtr) printf( "Allocation failed!\n" );
+   vtr = (double *)malloc((size_t)((nlast-nfirst+1+EDGE) * sizeof(double)));
+   if (!vtr) {
+     fprintf(stderr,"dVector: Allocation failed!\n");
+     return NULL;
+   } else
    return vtr-nfirst+EDGE;
 }
 
@@ -31,87 +39,121 @@
 float *fVector(long nfirst, long nlast)
 {
    float *vtr;
-   vtr = (float *)malloc( (size_t) ((nlast-nfirst+1+EDGE)*sizeof(float)) );
-   if(!vtr) printf( "Allocation failed!\n" );
+   vtr = (float *)malloc((size_t)((nlast-nfirst+1+EDGE) * sizeof(float)));
+   if (!vtr) {
+     fprintf(stderr,"fVector: Allocation failed!\n");
+     return NULL;
+   } else
    return vtr-nfirst+EDGE;
 }
 
-double **dMatrix(long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
-   long   i, nrow=nrowlast-nrowfirst+1, ncol=ncolumnlast-ncolumnfirst+1;
+double **dMatrix(int nrowfirst, int nrowlast,
+		 int ncolumnfirst, int ncolumnlast) {
+   int   i;
+   int nrow=(nrowlast-nrowfirst)+1;
+   int ncol=(ncolumnlast-ncolumnfirst)+1;
    double **mtr;
 
-   mtr = (double **) malloc( (size_t)((nrow+EDGE)*sizeof(double*)) );
-   if(!mtr) printf( "Allocation failed!\n" );
+   mtr = (double **)malloc((size_t)((nrow+EDGE) * sizeof(double*)));
+   if (!mtr) {
+     fprintf(stderr,"dMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr += EDGE;
    mtr -= nrowfirst;
 
-   mtr[nrowfirst] = (double *) malloc( (size_t)( (nrow*ncol+EDGE)*sizeof(double)));
-   if(!mtr[nrowfirst]) printf( "Allocation failed!\n" );
+   mtr[nrowfirst] = (double *)malloc((size_t)((nrow*ncol+EDGE)*
+					      sizeof(double)));
+   if (!mtr[nrowfirst]) {
+     fprintf(stderr,"dMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr[nrowfirst] += EDGE;
    mtr[nrowfirst] -= ncolumnfirst;
 
-   for(i=nrowfirst+1;i<=nrowlast;i++) mtr[i]=mtr[i-1]+ncol;
+   for (i=nrowfirst+1; i<=nrowlast; i++)
+     mtr[i] = mtr[i-1] + ncol;
 
    return mtr;
 }
 
-float **fMatrix(long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
+float **fMatrix(long nrowfirst, long nrowlast,
+		long ncolumnfirst, long ncolumnlast) {
    long   i, nrow=nrowlast-nrowfirst+1, ncol=ncolumnlast-ncolumnfirst+1;
    float **mtr;
 
-   mtr = (float **) malloc( (size_t)((nrow+EDGE)*sizeof(float*)) );
-   if(!mtr) printf( "Allocation failed!\n" );
+   mtr = (float **)malloc((size_t)((nrow+EDGE) * sizeof(float*)) );
+   if (!mtr) {
+     fprintf(stderr,"fMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr += EDGE;
    mtr -= nrowfirst;
 
-   mtr[nrowfirst] = (float *) malloc( (size_t)( (nrow*ncol+EDGE)*sizeof(float)));
-   if(!mtr[nrowfirst]) printf( "Allocation failed!\n" );
+   mtr[nrowfirst] = (float *)malloc((size_t)((nrow*ncol+EDGE)*sizeof(float)));
+   if (!mtr[nrowfirst]) {
+     fprintf(stderr,"fMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr[nrowfirst] += EDGE;
    mtr[nrowfirst] -= ncolumnfirst;
 
-   for(i=nrowfirst+1;i<=nrowlast;i++) mtr[i]=mtr[i-1]+ncol;
+   for (i=nrowfirst+1; i<=nrowlast; i++)
+     mtr[i] = mtr[i-1] + ncol;
 
    return mtr;
 }
 
-int **iMatrix(long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
+int **iMatrix(long nrowfirst, long nrowlast,
+	      long ncolumnfirst, long ncolumnlast) {
    long   i, nrow=nrowlast-nrowfirst+1, ncol=ncolumnlast-ncolumnfirst+1;
    int **mtr;
 
-   mtr = (int **) malloc( (size_t)((nrow+EDGE)*sizeof(int*)) );
-   if(!mtr) printf( "Allocation failed!\n" );
+   mtr = (int **)malloc((size_t)((nrow+EDGE) * sizeof(int*)));
+   if (!mtr) {
+     fprintf(stderr,"iMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr += EDGE;
    mtr -= nrowfirst;
 
-   mtr[nrowfirst] = (int *) malloc( (size_t)( (nrow*ncol+EDGE)*sizeof(int)));
-   if(!mtr[nrowfirst]) printf( "Allocation failed!\n" );
+   mtr[nrowfirst] = (int *)malloc((size_t)((nrow*ncol+EDGE) * sizeof(int)));
+   if (!mtr[nrowfirst]) {
+     fprintf(stderr,"iMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr[nrowfirst] += EDGE;
    mtr[nrowfirst] -= ncolumnfirst;
 
-   for(i=nrowfirst+1;i<=nrowlast;i++) mtr[i]=mtr[i-1]+ncol;
+   for (i=nrowfirst+1; i<=nrowlast; i++)
+     mtr[i] = mtr[i-1] + ncol;
 
    return mtr;
 }
 
-char **cMatrix(long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
+char **cMatrix(long nrowfirst, long nrowlast,
+	       long ncolumnfirst, long ncolumnlast) {
    long   i, nrow=nrowlast-nrowfirst+1, ncol=ncolumnlast-ncolumnfirst+1;
    char **mtr;
 
-   mtr = (char **) malloc( (size_t)((nrow+EDGE)*sizeof(char*)) );
-   if(!mtr) printf( "Allocation failed!\n" );
+   mtr = (char **)malloc((size_t)((nrow+EDGE) * sizeof(char*)));
+   if (!mtr) {
+     fprintf(stderr,"cMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr += EDGE;
    mtr -= nrowfirst;
 
-   mtr[nrowfirst] = (char *) malloc( (size_t)( (nrow*ncol+EDGE)*sizeof(char)));
-   if(!mtr[nrowfirst]) printf( "Allocation failed!\n" );
+   mtr[nrowfirst] = (char *)malloc((size_t)((nrow*ncol+EDGE) * sizeof(char)));
+   if (!mtr[nrowfirst]) {
+     fprintf(stderr,"cMatrix: Allocation failed!\n");
+     return NULL;
+   }
    mtr[nrowfirst] += EDGE;
    mtr[nrowfirst] -= ncolumnfirst;
 
-   for(i=nrowfirst+1;i<=nrowlast;i++) mtr[i]=mtr[i-1]+ncol;
+   for (i=nrowfirst+1; i<=nrowlast; i++)
+     mtr[i] = mtr[i-1] + ncol;
 
    return mtr;
 }
@@ -118,44 +160,44 @@
 
 void free_iVector(int *vtr, long nfirst, long nlast)
 {
-	free( (RELEASE) (vtr+nfirst-EDGE) );
+  free((RELEASE)(vtr+nfirst-EDGE));
 }
 
 void free_cVector(char *vtr, long nfirst, long nlast)
 {
-	free( (RELEASE) (vtr+nfirst-EDGE) );
+  free((RELEASE)(vtr+nfirst-EDGE));
 }
 
 void free_dVector(double *vtr, long nfirst, long nlast)
 {
-	free( (RELEASE) (vtr+nfirst-EDGE) );
+  free((RELEASE)(vtr+nfirst-EDGE));
 }
 
 void free_fVector(float *vtr, long nfirst, long nlast)
 {
-	free( (RELEASE) (vtr+nfirst-EDGE) );
+  free((RELEASE)(vtr+nfirst-EDGE));
 }
 
-void free_dMatrix(double **mtr, long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
-    free( (RELEASE) (mtr[nrowfirst]+ncolumnfirst-EDGE) );
-    free( (RELEASE) (mtr+nrowfirst-EDGE) );
+void free_dMatrix(double **mtr, int nrowfirst, int nrowlast,
+		  int ncolumnfirst, int ncolumnlast) {
+  free((RELEASE)(mtr[nrowfirst]+ncolumnfirst-EDGE));
+  free((RELEASE)(mtr+nrowfirst-EDGE));
 }
 
-void free_fMatrix(float **mtr, long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
-    free( (RELEASE) (mtr[nrowfirst]+ncolumnfirst-EDGE) );
-    free( (RELEASE) (mtr+nrowfirst-EDGE) );
+void free_fMatrix(float **mtr, long nrowfirst, long nrowlast,
+		  long ncolumnfirst, long ncolumnlast) {
+  free((RELEASE)(mtr[nrowfirst]+ncolumnfirst-EDGE));
+  free((RELEASE)(mtr+nrowfirst-EDGE));
 }
 
-void free_iMatrix(int **mtr, long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
-    free( (RELEASE) (mtr[nrowfirst]+ncolumnfirst-EDGE) );
-    free( (RELEASE) (mtr+nrowfirst-EDGE) );
+void free_iMatrix(int **mtr, long nrowfirst, long nrowlast,
+		  long ncolumnfirst, long ncolumnlast) {
+  free((RELEASE)(mtr[nrowfirst]+ncolumnfirst-EDGE));
+  free((RELEASE)(mtr+nrowfirst-EDGE));
 }
 
-void free_cMatrix(char **mtr, long nrowfirst, long nrowlast, long ncolumnfirst, long ncolumnlast)
-{
-    free( (RELEASE) (mtr[nrowfirst]+ncolumnfirst-EDGE) );
-    free( (RELEASE) (mtr+nrowfirst-EDGE) );
+void free_cMatrix(char **mtr, long nrowfirst, long nrowlast,
+		  long ncolumnfirst, long ncolumnlast) {
+  free((RELEASE)(mtr[nrowfirst]+ncolumnfirst-EDGE));
+  free((RELEASE)(mtr+nrowfirst-EDGE));
 }
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/matvecalloc.h lsqrms-2.0.4b/src/matvecalloc.h
--- lsqrms-2.0.4b.old/src/matvecalloc.h
+++ lsqrms-2.0.4b/src/matvecalloc.h	Sun Feb 24 22:49:49 EST 2008
@@ -0,0 +1,30 @@
+#ifndef MATVECALLOC_H
+#define MATVECALLOC_H
+
+#define RELEASE char*
+
+#include "lsqrms.h"
+
+#if HAVE_MEMORY_H
+# include <memory.h>
+#endif
+
+char    *cVector(long, long);
+int     *iVector(long, long);
+double  *dVector(long, long);
+float   *fVector(long, long);
+char   **cMatrix(long, long, long, long);
+int    **iMatrix(long, long, long, long);
+double **dMatrix(int, int, int, int);
+float  **fMatrix(long, long, long, long);
+
+void free_cVector(char*, long, long);
+void free_dVector(double*, long, long);
+void free_iVector(int*, long, long);
+void free_fVector(float*, long, long);
+void free_cMatrix(char**, long, long, long, long);
+void free_iMatrix(int**, long, long, long, long);
+void free_dMatrix(double**, int, int, int, int);
+void free_fMatrix(float**, long, long, long, long);
+
+#endif
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/matvecutils.c lsqrms-2.0.4b/src/matvecutils.c
--- lsqrms-2.0.4b.old/src/matvecutils.c	Wed Mar 12 17:12:16 EST 2003
+++ lsqrms-2.0.4b/src/matvecutils.c	Sun Feb 24 22:49:50 EST 2008
@@ -1,408 +1,263 @@
-#include <math.h>
-#include <stdio.h>
-
-
-#include "umath.h"
-
-
-
-typedef double rotate_t[3][3];
-
-typedef double xlate_t[3];
-
-typedef struct Coord { double x, y, z; } CoordType;
-
-
-
-int     *iVector(long, long);
-
-int    **iMatrix(long, long, long, long);
-
-double  *dVector(long, long);
-
-char    *cVector(long, long);
-
-double **dMatrix(long, long, long, long);
-
-void free_iVector(int     *, long, long);
-
-void free_iMatrix(int    **, long, long, long, long);
-
-void free_dVector(double  *, long, long);
-
-void free_dMatrix(double **, long, long, long, long);
-
-void free_cVector(char    *, long, long);
-
-
-
-/*=====================================================================*/
-
-static int solve(double e[3],
-
-                   double e0, double det, double spur, double cof)
-
-{
-
-double d, h, g, cth, sth, sqrth;
-
-#define epsilon 1e-7
-
-#define sqrt3 1.7320508075688772
-
-  
-
-  det *= det;
-
-  d = SQR(spur);
-
-  h = d - cof;
-
-  g = spur * (cof*1.5 - d) - det*0.5;
-
-  if (h > d*epsilon) {
-
-    sqrth = SQRTABS(h);
-
-    d = -g/(h*sqrth);
-
-    if (d > 1-epsilon) {    /* Two identical roots */
-
-      e[0] = spur + 2*sqrth;
-
-      e[2] = e[1] = spur - sqrth;
-
-      return 2;
-
-      }
-
-    else if (d < -1+epsilon) {    /* Two identical roots */ 
-
-      e[1] = e[0] = spur+sqrth;
-
-      e[2] = MAX(0, spur - 2*sqrth);
-
-      return 3;
-
-      }
-
-    else {    /* Three distinct roots */
-
-      d = acos(d)/3.0;
-
-      cth = sqrth*cos(d); sth = sqrth*sqrt3*sin(d);
-
-      e[0] = spur + 2*cth;
-
-      e[1] = spur - cth + sth;
-
-      e[2] = MAX(0, spur - cth - sth);
-
-      return 1;
-
-      }
-
-    }
-
-  else {    /* Three identical roots */ 
-
-    e[0] = e[1] = e[2] = spur;
-
-    return 4;
-
-    }
-
-
-
- } /* solve */
-
-
-
-
-
-static int matrix(rotate_t u, xlate_t t,
-
-                   int sw, double e[3], double rr[6], double r[3][3],
-
-                   double sx[3], double sy[3], int npts)
-
-{
-
-  double ss[6], d, h, p, a[3][3], b[3][3];
-
-  int i, j, l, m, m1, m2, m3;
-
-
-
-  if (sw == 4) {
-
-    /* Case of three identical roots */
-
-    for (i = 0; i < 3; i++)
-
-      for (j = 0; j < 3; j++)
-
-        if (i == j) a[i][j] = 1.0; else a[i][j] = 0.0;
-
-    }
-
-  else {
-
-    if (sw == 1) {
-
-      /* Case of three distinct roots */
-
-      for (l=0; l < 2; l++) {
-
-        d = e[l];
-
-        ss[0] = (d-rr[2]) * (d-rr[5]) - SQR(rr[4]);
-
-        ss[1] = (d-rr[5]) * rr[1] + rr[3]*rr[4];
-
-        ss[2] = (d-rr[0]) * (d-rr[5]) - SQR(rr[3]);
-
-        ss[3] = (d-rr[2]) * rr[3] + rr[1]*rr[4];
-
-        ss[4] = (d-rr[0]) * rr[4] + rr[1]*rr[3];
-
-        ss[5] = (d-rr[0]) * (d-rr[2]) - SQR(rr[1]);
-
-        if (FABS(ss[0]) >= FABS(ss[2])) {
-
-          if (FABS(ss[0]) >= FABS(ss[5])) {
-
-            a[0][l] = ss[0]; a[1][l] = ss[1]; a[2][l] = ss[3];
-
-            }
-
-          else {
-
-            a[0][l] = ss[3]; a[1][l] = ss[4]; a[2][l] = ss[5];
-
-            }
-
-          }
-
-        else if (FABS(ss[2]) >= FABS(ss[5])) {
-
-          a[0][l] = ss[1]; a[1][l] = ss[2]; a[2][l] = ss[4];
-
-          }
-
-        else {
-
-          a[0][l] = ss[3]; a[1][l] = ss[4]; a[2][l] = ss[5];
-
-          }
-
-        d = sqrt(SQR(a[0][l]) + SQR(a[1][l]) + SQR(a[2][l]));
-
-        a[0][l] /= d; a[1][l] /= d; a[2][l] /= d;
-
-        }
-
-      m1 = 2; m2 = 0; m3 = 1;
-
-      }
-
-    else {
-
-      /* Cases of two distinct roots */
-
-      if (sw == 2) {
-
-        m = 0; m1 = 2; m2 = 0; m3 = 1;
-
-        }
-
-      else {
-
-        m = 2; m1 = 0; m2 = 1; m3 = 2;
-
-        }
-
-      h = e[2];
-
-      a[0][1] = 1.0; a[1][1] = 1.0; a[2][1] = 1.0;
-
-      if (FABS(rr[0]-h) > FABS(rr[2]-h)) {
-
-        if (FABS(rr[0]-h) > FABS(rr[5]-h)) {
-
-          a[0][m] = rr[0]-h; a[1][m] = rr[1]; a[2][m] = rr[3];
-
-          p = -(rr[0] + rr[1] + rr[3] - h);
-
-          a[0][1] = p/a[0][m];
-
-          }
-
-        else {
-
-          a[0][m] = rr[3]; a[1][m] = rr[4]; a[2][m] = rr[5]-h;
-
-          p = -(rr[3] + rr[4] + rr[5] - h);
-
-          a[2][1] = p/a[2][m];
+#include "lsqrms.h"
+#include "umath.h"
+#include "matvecalloc.h"
+#include "matvecutils.h"
 
-          }
+static int solve(LDBL [], LDBL, LDBL, LDBL, LDBL);
+static double TRvec(double *, double **, double *);
+static LDBL vsumby3(double [], int);
+static LDBL vsumsqr(double [], int);
+static LDBL vdotby3(double [], double [], int);
 
-        }
 
-      else {
+/*=====================================================================*/
 
-        if (FABS(rr[2]-h) > FABS(rr[5]-h)) {
+static int solve(LDBL e[3],LDBL e0, LDBL det, LDBL spur, LDBL cof) {
+  LDBL d, h, g, cth, sth, sqrth;
 
-          a[0][m] = rr[1]; a[1][m] = rr[2]-h; a[2][m] = rr[4];
+#define sqrt3 1.732050807568877293527446341506
 
-          p = -(rr[1] + rr[2] + rr[4] - h);
+  d = DSQR(spur);
 
-          a[1][1] = p/a[1][m];
+  h = d - cof;
 
-          }
+  if (h > d*epsilon) {
+    det *= det;
+    g = spur * (cof*1.5 - d) - det*0.5;
 
-        else {
+    sqrth = DSQRTABS(h);
 
-          a[0][m] = rr[3]; a[1][m] = rr[4]; a[2][m] = rr[5]-h;
+    d = -g/(h*sqrth);
 
-          p = -(rr[3] + rr[4] + rr[5] - h);
+    if (d > 1-epsilon) {    /* Two identical roots */
+      e[0] = spur + 2*sqrth;
+      e[2] = e[1] = spur - sqrth;
 
-          a[2][1] = p/a[2][m];
+      return 2;
+    } else if (d < -1+epsilon) {    /* Two identical roots */ 
+      e[1] = e[0] = spur+sqrth;
+      e[2] = MAX(0, spur - 2*sqrth);
 
-          }
+      return 3;
+    } else {    /* Three distinct roots */
+      d = DACOS(d)/3.0;
 
-        }
+      cth = sqrth*DCOS(d);
+      sth = sqrth*sqrt3*DSIN(d);
 
-      d = sqrt(SQR(a[0][m]) + SQR(a[1][m]) + SQR(a[2][m]));
+      e[0] = spur + 2*cth;
+      e[1] = spur - cth + sth;
+      e[2] = MAX(0, spur - cth - sth);
 
-      p = sqrt(SQR(a[0][1]) + SQR(a[1][1]) + SQR(a[2][1]));
+      return 1;
+    }
 
-      for (i = 0; i < 3; i++) {
+  } else {    /* Three identical roots */ 
+    e[0] = e[1] = e[2] = spur;
 
-        a[i][1] /= p;
+    return 4;
+  }
+} /* solve */
 
-        a[i][m] /= d;
+static void matrix(rotate_t u, xlate_t t, int sw, LDBL e[3],
+		   LDBL rr[6], LDBL r[3][3],
+		   LDBL sx[3], LDBL sy[3], int npts) {
+  LDBL ss[6], d, h, p, a[3][3], b[3][3];
+  int i, j, l, m, m1, m2, m3;
 
-        }
+  if (sw == 4) {
+    /* Case of three identical roots */
+    for (i = 0; i < 3; i++) {
+      for (j = 0; j < 3; j++) {
+        if (i == j)
+	  a[i][j] = 1.0;
+	else
+	  a[i][j] = 0.0;
+      }
+    }
+  } else {
+    if (sw == 1) {
+      /* Case of three distinct roots */
+      for (l=0; l < 2; l++) {
+        d = e[l];
 
-      }
+        ss[0] = (d-rr[2]) * (d-rr[5]) - DSQR(rr[4]);
+        ss[1] = (d-rr[5]) * rr[1] + rr[3]*rr[4];
+        ss[2] = (d-rr[0]) * (d-rr[5]) - DSQR(rr[3]);
+        ss[3] = (d-rr[2]) * rr[3] + rr[1]*rr[4];
+        ss[4] = (d-rr[0]) * rr[4] + rr[1]*rr[3];
+        ss[5] = (d-rr[0]) * (d-rr[2]) - DSQR(rr[1]);
 
-    /* Common for either two or three distinct roots */
+        if (FABS(ss[0]) >= FABS(ss[2])) {
+          if (FABS(ss[0]) >= FABS(ss[5])) {
+            a[0][l] = ss[0];
+	    a[1][l] = ss[1];
+	    a[2][l] = ss[3];
+	  } else {
+            a[0][l] = ss[3];
+	    a[1][l] = ss[4];
+	    a[2][l] = ss[5];
+	  }
+	} else if (FABS(ss[2]) >= FABS(ss[5])) {
+          a[0][l] = ss[1];
+	  a[1][l] = ss[2];
+	  a[2][l] = ss[4];
+	} else {
+          a[0][l] = ss[3];
+	  a[1][l] = ss[4];
+	  a[2][l] = ss[5];
+	}
 
-    a[0][m1] = a[1][m2]*a[2][m3] - a[1][m3]*a[2][m2];
+        d = DSQRT(DSQR(a[0][l]) + DSQR(a[1][l]) + DSQR(a[2][l]));
 
-    a[1][m1] = a[2][m2]*a[0][m3] - a[2][m3]*a[0][m2];
+        a[0][l] /= d;
+	a[1][l] /= d;
+	a[2][l] /= d;
+      }
 
-    a[2][m1] = a[0][m2]*a[1][m3] - a[0][m3]*a[1][m2];
+      m1 = 2; m2 = 0; m3 = 1;
+    } else {
+      /* Cases of two distinct roots */
+      if (sw == 2) {
+        m = 0;
+	m1 = 2;
+	m2 = 0;
+	m3 = 1;
+      } else {
+        m = 2;
+	m1 = 0;
+	m2 = 1;
+	m3 = 2;
+      }
 
-    }
+      h = e[2];
 
-  
+      a[0][1] = 1.0;
+      a[1][1] = 1.0;
+      a[2][1] = 1.0;
 
-  for (l = 0; l < 2; l++) {
+      if (FABS(rr[0]-h) > FABS(rr[2]-h)) {
+        if (FABS(rr[0]-h) > FABS(rr[5]-h)) {
+          a[0][m] = rr[0]-h;
+	  a[1][m] = rr[1];
+	  a[2][m] = rr[3];
 
-    d = 0;
+          p = -(rr[0] + rr[1] + rr[3] - h);
 
-    for (i = 0; i < 3; i++) {
+          a[0][1] = p/a[0][m];
+	} else {
+          a[0][m] = rr[3];
+	  a[1][m] = rr[4];
+	  a[2][m] = rr[5]-h;
 
-      b[i][l] = r[0][i]*a[0][l] + r[1][i]*a[1][l] + r[2][i]*a[2][l];
+          p = -(rr[3] + rr[4] + rr[5] - h);
 
-      d += SQR(b[i][l]);
+          a[2][1] = p/a[2][m];
+	}
+      } else {
+        if (FABS(rr[2]-h) > FABS(rr[5]-h)) {
+          a[0][m] = rr[1];
+	  a[1][m] = rr[2]-h;
+	  a[2][m] = rr[4];
 
-      }
+          p = -(rr[1] + rr[2] + rr[4] - h);
 
-    d = sqrt(d);
+          a[1][1] = p/a[1][m];
+	} else {
+          a[0][m] = rr[3];
+	  a[1][m] = rr[4];
+	  a[2][m] = rr[5]-h;
 
-    if (d == 0) printf("degenerate rotation matrix in matrix()\n"); 
+          p = -(rr[3] + rr[4] + rr[5] - h);
 
-    for (i = 0; i < 3; i++) b[i][l] /= d;
+          a[2][1] = p/a[2][m];
+	}
+      }
 
-    }
+      d = sqrt(DSQR(a[0][m]) + DSQR(a[1][m]) + DSQR(a[2][m]));
+      p = sqrt(DSQR(a[0][1]) + DSQR(a[1][1]) + DSQR(a[2][1]));
 
-  b[0][2] = b[1][0]*b[2][1] - b[1][1]*b[2][0];
+      for (i = 0; i < 3; i++) {
+        a[i][1] /= p;
+        a[i][m] /= d;
+      }
+    }
 
-  b[1][2] = b[2][0]*b[0][1] - b[2][1]*b[0][0];
+    /* Common for either two or three distinct roots */
 
-  b[2][2] = b[0][0]*b[1][1] - b[0][1]*b[1][0];
+    a[0][m1] = a[1][m2]*a[2][m3] - a[1][m3]*a[2][m2];
+    a[1][m1] = a[2][m2]*a[0][m3] - a[2][m3]*a[0][m2];
+    a[2][m1] = a[0][m2]*a[1][m3] - a[0][m3]*a[1][m2];
+  }
 
-  
+  for (l = 0; l < 2; l++) {
+    d = 0.0;
 
-  /* Calculate rotation matrix */
+    for (i = 0; i < 3; i++) {
+      b[i][l] = r[0][i]*a[0][l] + r[1][i]*a[1][l] + r[2][i]*a[2][l];
 
-  for (i = 0; i < 3; i++)
+      d += SQR(b[i][l]);
+    }
 
-    for (j = 0; j < 3; j++)
+    d = DSQRT(d);
 
-      u[i][j] = b[i][0]*a[j][0] + b[i][1]*a[j][1] + b[i][2]*a[j][2];
+    if (d == 0.0) {
+      fprintf(stderr,"matrix: degenerate rotation matrix!\n");
+      exit(1);
+    } else {
+      for (i = 0; i < 3; i++)
+	b[i][l] /= d;
+    }
+  }
 
-  /* Calculate translation vector */
+  b[0][2] = b[1][0]*b[2][1] - b[1][1]*b[2][0];
+  b[1][2] = b[2][0]*b[0][1] - b[2][1]*b[0][0];
+  b[2][2] = b[0][0]*b[1][1] - b[0][1]*b[1][0];
 
-  for (i = 0; i < 3; i++)
+  /* Calculate rotation matrix */
 
-    t[i] = (sy[i] - u[i][0]*sx[0] - u[i][1]*sx[1] - u[i][2]*sx[2])/npts;
+  for (i = 0; i < 3; i++) {
+    for (j = 0; j < 3; j++)
+      u[i][j] = (double)(b[i][0]*a[j][0] + b[i][1]*a[j][1] + b[i][2]*a[j][2]);
+  }
 
-
+  /* Calculate translation vector */
 
-  return 7;
+  for (i = 0; i < 3; i++)
+    t[i] =
+      (double)((sy[i] - u[i][0]*sx[0] - u[i][1]*sx[1] - u[i][2]*sx[2])/npts);
 
-}
+  /* return 7; */
+}
 
 
-double bestfit(rotate_t u, xlate_t t, CoordType *a, CoordType *b, const int npts)
-{
-  double sx[3], sy[3], sxy[3][3], sx2, sy2, temp; 
-  double r[3][3], rr[6];
-  double d, spur, det, cof, e0, e[3], inpts;
+double bestfit(rotate_t u, xlate_t t, CoordType *a, CoordType *b,
+	       const int npts) {
+  LDBL sx[3], sy[3], sxy[3][3], sx2, sy2;
+  LDBL r[3][3], rr[6];
+  LDBL d, spur, det, cof, e0, e[3], inpts;
   int i, j, m, sw;
-
-
-  double vsumby3(double [], int);
-
-  double vsumsqr(double [], int);
-
-  double vdotby3(double [], double [], int n);
-
-
-
-  temp = vsumby3(&a[0].x, npts);
-
-  temp = vsumby3(&a[0].y, npts);
-
-  temp = vsumby3(&a[0].z, npts);
-
-  temp = vsumby3(&b[0].x, npts);
-
-  temp = vsumby3(&b[0].y, npts);
-
-  temp = vsumby3(&b[0].z, npts);
-
-
-
-  temp = vsumsqr(&a[0].x, 3*npts);
-
-  temp = vsumsqr(&b[0].x, 3*npts);
-
-
-
-  temp = vdotby3(&a[0].x, &b[0].x, npts);
-
-  temp = vdotby3(&a[0].x, &b[0].y, npts);
-
-  temp = vdotby3(&a[0].x, &b[0].z, npts);
 
-  temp = vdotby3(&a[0].y, &b[0].x, npts);
-
-  temp = vdotby3(&a[0].y, &b[0].y, npts);
-
-  temp = vdotby3(&a[0].y, &b[0].z, npts);
-
-  temp = vdotby3(&a[0].z, &b[0].x, npts);
+  (void)vsumby3(&a[0].x, npts);
+  (void)vsumby3(&a[0].y, npts);
+  (void)vsumby3(&a[0].z, npts);
 
-  temp = vdotby3(&a[0].z, &b[0].y, npts);
+  (void)vsumby3(&b[0].x, npts);
+  (void)vsumby3(&b[0].y, npts);
+  (void)vsumby3(&b[0].z, npts);
 
-  temp = vdotby3(&a[0].z, &b[0].z, npts);
+  (void)vsumsqr(&a[0].x, 3*npts);
+  (void)vsumsqr(&b[0].x, 3*npts);
 
+  (void)vdotby3(&a[0].x, &b[0].x, npts);
+  (void)vdotby3(&a[0].x, &b[0].y, npts);
+  (void)vdotby3(&a[0].x, &b[0].z, npts);
+  (void)vdotby3(&a[0].y, &b[0].x, npts);
+  (void)vdotby3(&a[0].y, &b[0].y, npts);
+  (void)vdotby3(&a[0].y, &b[0].z, npts);
+  (void)vdotby3(&a[0].z, &b[0].x, npts);
+  (void)vdotby3(&a[0].z, &b[0].y, npts);
+  (void)vdotby3(&a[0].z, &b[0].z, npts);
 
   sx[0] = vsumby3(&a[0].x, npts);
   sx[1] = vsumby3(&a[0].y, npts);
@@ -423,8 +278,8 @@
   sxy[2][2] = vdotby3(&a[0].z, &b[0].z, npts);
 
   inpts = 1.0/npts;
-  e0 = (sx2 - (SQR(sx[0])+SQR(sx[1])+SQR(sx[2]))*inpts +
-        sy2 - (SQR(sy[0])+SQR(sy[1])+SQR(sy[2]))*inpts)*inpts;
+  e0 = (sx2 - (DSQR(sx[0])+DSQR(sx[1])+DSQR(sx[2]))*inpts +
+        sy2 - (DSQR(sy[0])+DSQR(sy[1])+DSQR(sy[2]))*inpts)*inpts;
 
   for (i = 0; i < 3; i++) {
     for (j = 0; j < 3; j++) {
